/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.util.DateValidate
 *  fire.pb.util.singlefactory.SingleContainer
 *  gnet.link.Onlines
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.RegDay
 *  xbean.RegMonth
 *  xbean.RegRec
 */
package fire.pb.activity.reg;

import fire.pb.activity.reg.PRmOutOfDateRec;
import fire.pb.activity.reg.RegAssistant;
import fire.pb.activity.reg.SQueryRegData;
import fire.pb.util.DateValidate;
import fire.pb.util.singlefactory.SingleContainer;
import gnet.link.Onlines;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.Map;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.RegDay;
import xbean.RegMonth;
import xbean.RegRec;

public class PQueryRegRec
extends Procedure {
    private long roleId;
    private RegAssistant regAssistant;

    public PQueryRegRec(long roleId, RegAssistant assistant) {
        this.roleId = roleId;
        this.regAssistant = assistant;
    }

    public PQueryRegRec(long roleId) {
        this(roleId, (RegAssistant)SingleContainer.getInstance(RegAssistant.class));
    }

    protected boolean process() throws Exception {
        Calendar calen = Calendar.getInstance();
        int monthOfYear = this.regAssistant.getMonthOfYear(calen);
        int dayOfMonth = this.regAssistant.getDayOfMonth(calen);
        RegRec record = this.regAssistant.getRecord(this.roleId);
        long createTime = this.regAssistant.getRoleCreateTime(this.roleId);
        long now = calen.getTimeInMillis();
        this.checkOutDate(record.getLastregtime(), now);
        Map days = Collections.emptyMap();
        if (record.getMonthmap().containsKey(monthOfYear)) {
            days = ((RegMonth)record.getMonthmap().get(monthOfYear)).getDaymap();
        }
        this.sendRegMsg(days, monthOfYear, dayOfMonth, createTime, now);
        return true;
    }

    protected void sendRegMsg(Map<Integer, RegDay> regDayMap, int month, int today, long roleCreateTime, long now) {
        if (regDayMap == null) {
            return;
        }
        SQueryRegData msg = new SQueryRegData();
        msg.month = month;
        msg.rewardflag = regDayMap.containsKey(today) ? regDayMap.get(today).getRewardflag() : 0;
        int cansuppregtimes = 0;
        for (int day : regDayMap.keySet()) {
            if (regDayMap.get(day).getSuppregflag() <= 0) continue;
            msg.suppregdays.add(day);
        }
        if (roleCreateTime != 0L && !DateValidate.inTheSameMonth((long)roleCreateTime, (long)now)) {
            for (int di = 1; di < today; ++di) {
                RegDay rDay = regDayMap.get(di);
                if (rDay != null) {
                    if (rDay.getSuppregflag() > 0 || rDay.getRewardflag() > 0) continue;
                    ++cansuppregtimes;
                    continue;
                }
                ++cansuppregtimes;
            }
        } else if (roleCreateTime != 0L && DateValidate.inTheSameMonth((long)roleCreateTime, (long)now)) {
            int cDay;
            Calendar calen = Calendar.getInstance();
            calen.setTime(new Date(roleCreateTime));
            for (int di = cDay = calen.get(5); di < today; ++di) {
                RegDay rDay = regDayMap.get(di);
                if (rDay != null) {
                    if (rDay.getSuppregflag() > 0 || rDay.getRewardflag() > 0) continue;
                    ++cansuppregtimes;
                    continue;
                }
                ++cansuppregtimes;
            }
        }
        msg.times = this.regAssistant.getRegTimesOfMonth(regDayMap);
        msg.suppregtimes = this.regAssistant.getSuppRegTimesOfMonth(this.roleId, month);
        msg.cansuppregtimes = cansuppregtimes;
        Onlines.getInstance().send(Long.valueOf(this.roleId), (Protocol)msg);
    }

    protected void checkOutDate(long lastRegTime, long now) {
        if (lastRegTime < 1L) {
            return;
        }
        if (!DateValidate.inTheSameMonth((long)lastRegTime, (long)now)) {
            new PRmOutOfDateRec(this.roleId, lastRegTime).call();
        }
    }
}

